{
  Autor: Michael Springwald

  Erstellt: Samstag, 29.September.2007

  Updates
  --------------------------------------------------------------
  - Dienstag, 30.Oktober.2007 - Dienstag, 06.November.2007     -
  --------------------------------------------------------------
  - Samstag, 24.Novmeber.2007 - Dienstag, 01.Janur.2008        -
  --------------------------------------------------------------
  - Mittwoch, 02.Janur.2008   - Donnerstag, 03.Januer.2008     -                                -
  --------------------------------------------------------------
  - Mittwoch, 09.Janur.2008   - Donnerstag, 13.Janur.2008      -
  --------------------------------------------------------------
  - Mittwoch, 30.Janur.2008   - Mittwoch, 26, März.2008        -
  --------------------------------------------------------------
  -                           -                                -
  --------------------------------------------------------------
  -                           -                                -
  --------------------------------------------------------------
  -                           -                                -
  --------------------------------------------------------------
  -                           -                                -
  --------------------------------------------------------------

}

unit uplaylistbase;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, contnrs, IniFiles{, XMLRead, DOM};

type
  TPlaylistenItem = class
    Playtime: Integer;  // Spielzeit in Sekunden oder 0
    FileName:widestring;
    Kommentar:widestring;
    Len:Integer;
      end;

  TOnAddPlayliste = procedure (const aFileName:widestring; const aInfo:TPlaylistenItem) of object;
  TOnGetPlaylisteItem = procedure (const aInfo:TPlaylistenItem) of object;
  
// -------------------------------------------------------------------
//   TPlaylistBase
// -------------------------------------------------------------------
  TPlaylistBase = class
    FonAddPlayListe: TOnAddPlayliste;
  private

  protected

  public
    // Wird für das Speichern benötigt
    FileList:TStringList;
    
    FileName:widestring;
    OhneExt:Boolean;
    // Enhält den Titel bei m3u und pls einfach der Dateinamen
    // Bei wpl der Titel der in der Datei drin steht
    Titel:widestring;
    
    // Wird automatisch von LoadFromFile zugewiesen
    // Wird wegen den M3U datei benötigt.
    // und noch wegen anderen Formaten z.b. wpl
    ext:widestring;

    procedure SaveToFile(aStringlist:TStrings; const aFileName:widestring = ''); Virtual; Abstract;
    procedure LoadFromFile(aStringlist:TStrings; const aFileName:widestring); Virtual; Abstract;

    constructor Create;
    destructor Destory;
  published
    property onAddPlayListe: TOnAddPlayliste read FonAddPlayListe write FonAddPlayListe;

  end; // TPlaylistBase

// --------------------------------------------------------------------
//  TPlayListM3U
// -------------------------------------------------------------------

  TPlayListM3U = class(TPlaylistBase)
  private

  protected

  public
    procedure SaveToFile(aStringlist:TStrings; const aFileName:widestring = ''); override;
    procedure LoadFromFile(aStringlist:TStrings; const aFileName:widestring); override;
  end; // TPlayListM3U

// --------------------------------------------------------------------
//   TPlayListPLS
// -------------------------------------------------------------------

  TPlayListPLS = class(TPlaylistBase)
  private
  protected

  public
    procedure SaveToFile(aStringlist:TStrings; const aFileName:widestring = ''); override;
    procedure LoadFromFile(aStringlist:TStrings; const aFileName:widestring); override;
  end; // TPlayListPLS

// --------------------------------------------------------------------
//   TPlayListWPL
// -------------------------------------------------------------------
  TPlayListWPL = class(TPlaylistBase)
  private
  protected
  public
    procedure SaveToFile(aStringlist:TStrings; const aFileName:widestring = ''); override;
    procedure LoadFromFile(aStringlist:TStrings; const aFileName:widestring); override;
  end; // TPlayListWPL

// --------------------------------------------------------------------
// Hilfs Funktionen
// --------------------------------------------------------------------

function SplitStr(str:widestring;ch:char):widestring;
// --------------------------------------------------------------------

implementation

{ TPlaylistBase }

function RandomID2A(count:Integer):widestring;
const
  noChar = ':\-._';
  abc1    = 'abcdefghijklmnopqrstuvwxyz';
  abc2    = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
  Zahlen  = '0123456789';
var
  x,len:Integer;
  s:widestring;
  i:Byte;
  z:widestring;
  str:widestring;
begin
  s:='';z:='';
  str:=abc1+abc2+Zahlen;
  len:=Length(str);
  
  for x:=1 to count do begin
    i:=random(len)+1;
    z:=str[i];

    if Pos(z,noChar) > 0 then begin
      repeat
        i:=random(len)+1;
        z:=str[i];
      until Pos(z,noChar) = 0;
    end;
    if z <> '' then
    s:=s + z;
  end;
  result:=s;
end; // RandomID2A

function RandomGUI:widestring;
begin
  result:='{'+RandomID2A(8)+'-'+RandomID2A(4)+'-'+RandomID2A(4)+'-'+RandomID2A(4)+'-'+RandomID2A(12)+'}'
end; // RandomGUI:widestring

function SplitStr(str:widestring;ch:char):widestring;
var
  i:Integer;
begin
  for i:=(Length(str)-1) downto 1 do begin
    if str[i] = ch then begin
      Delete(str,i,Length(str));
      Break;
    end;
  end;
  result:=str;
end;

constructor TPlaylistBase.Create;
begin
  inherited Create;
  FileList:=TStringList.Create;
end;

destructor TPlaylistBase.Destory;
begin
  FileList.Free;
end;

// --------------------------------------------------------------------
{ TPlayListM3U }
// --------------------------------------------------------------------
procedure TPlayListM3U.SaveToFile(aStringlist:TStrings; const aFileName: widestring);
var
  i:integer;
  info:TPlaylistenItem;
begin
  writeln('M3U SaveToFile Begin');

  if ext <> '' then  FileList.Add(ext);

  for i:=0 to aStringlist.count-1 do begin
    if aStringlist.Objects[i] is TPlaylistenItem then begin
      info:=TPlaylistenItem(aStringlist.Objects[i]);
      if info.Kommentar <> '' then FileList.Add(info.Kommentar);
      FileList.Add(info.FileName);
    end;
  end;
  writeln('M3U SaveToFile End');
end; // TPlayListM3U.SaveToFile

procedure TPlayListM3U.LoadFromFile(aStringlist:TStrings; const aFileName: widestring);
var
  str, str2:string;
  Item:TPlaylistenItem;
  F: TextFile;
begin
  writeln('M3U LoadFormFile Begin');

  Titel:=SplitStr(ExtractFileName(aFileName),'.');
  AssignFile(F, aFileName); Reset(F); ReadLn(F, str);
  if UpperCase(str) = '#EXTM3U' then begin
    ext:=str;
    ReadLn(F, str);
  end
  else
    ext:='';

  str2:='';
  SetCurrentDir(ExtractFileDir(aFileName));
  while not EOF(f) do begin
    if str <> '' then begin
      if str[1] = '#' then
       str2 := str
      else begin
        Item:=TPlaylistenItem.Create;
        Item.FileName := ExpandFileName(str);
        Item.Kommentar:= str2;
        if OhneExt then begin
          aStringlist.AddObject(SplitStr(ExtractFileName(Item.FileName),'.'),Item);
          if assigned(onAddPlayListe) then
            onAddPlayListe(item.FileName,item);
        end
        else begin
          aStringlist.AddObject(ExtractFileName(Item.FileName),Item);
          if assigned(onAddPlayListe) then
            onAddPlayListe(ExtractFileName(item.FileName),item);
        end;
        str2:='';
      end;
      ReadLn(F, Str);
    end;
  end; // While
  CloseFile(f);
  writeln('M3U LoadFromFile End');
end; // TPlayListM3U.LoadFromFile

// --------------------------------------------------------------------
{ TPlayListPLS }
// --------------------------------------------------------------------
procedure TPlayListPLS.SaveToFile(aStringlist:TStrings; const aFileName: widestring);
var
  Count,i:Integer;
  Item:TPlaylistenItem;
begin
  writeln('PLS SaveToFile');
  Count:=aStringList.Count;
  FileList.add('[playlist]');
  FileList.add('NumberOfEntries='+IntTostr(Count));
  for i:=1 to Count do begin
    Item:=TPlaylistenItem(aStringlist.Objects[i-1]);
    FileList.add('File'+IntTostr(i) + '=' + Item.FileName);

    if Item.Kommentar <> '' then
      FileList.add('Title'+IntTostr(i) + '=' + ExtractFileName(SplitStr(Item.FileName,'.')));

    if item.Playtime > 0 then
      FileList.add('Length'+IntTostr(i) + '=' + IntToStr((Item.Playtime)));
  end; // for i
  writeln('PLS SaveToFile End');
end; // TPlayListPLS.SaveToFile

procedure TPlayListPLS.LoadFromFile(aStringlist:TStrings; const aFileName: widestring);
var
  Count,i:Integer;
  Item:TPlaylistenItem;
  IniFile:TIniFile;
begin
  writeln('PLS LoadFromFile Begin');

  Titel:=SplitStr(ExtractFileName(aFileName),'.');

  IniFile:=TIniFile.Create(aFileName);
  with IniFile do begin
    Count:=ReadInteger('playlist','NumberOfEntries',0);
    SetCurrentDir(ExtractFileDir(aFileName));
    for i:=1 to Count do begin
      Item:=TPlaylistenItem.Create;
      if ValueExists('playlist','File'+IntTostr(i)) then
        Item.FileName:=ExpandFileName(ReadString('playlist','File'+IntTostr(i),''));
        
      if ValueExists('playlist','Title'+IntTostr(i)) then
        Item.Kommentar:=ReadString('playlist','Title'+IntTostr(i),'');

      if ValueExists('playlist','Length'+IntTostr(i)) then
        Item.Playtime:=ReadInteger('playlist','Length'+IntTostr(i),0);

        if OhneExt then begin
          aStringlist.AddObject(SplitStr(ExtractFileName(Item.FileName),'.'),Item);
          if assigned(onAddPlayListe) then
            onAddPlayListe(item.FileName,item);
        end
        else begin
          aStringlist.AddObject(ExtractFileName(Item.FileName),Item);
          if assigned(onAddPlayListe) then
            onAddPlayListe(ExtractFileName(item.FileName),item);
        end;
    end;
  end; // with
  IniFile.Free;
  writeln('PLS LoadFromFile End');
end; // TPlayListPLS.LoadFromFile

// --------------------------------------------------------------------
{ TPlayListWPL }
// --------------------------------------------------------------------
procedure TPlayListWPL.SaveToFile(aStringlist: TStrings;
  const aFileName: widestring);
var
  Item:TPlaylistenItem;
  i:integer;
  str,id:widestring;
begin
  writeln('WPL: SaveToFile Begin');
  FileList:=TStringList.Create;
  FileList.Add('<?wpl version="1.0"?>');
  FileList.Add(' <smil>');
  FileList.Add('     <head>');
  FileList.Add('         <meta name="Generator" content="Playlisten Klasse von Pluto -- 1.0"/>');
  FileList.Add('         <title>'+Titel+' </title>');
  FileList.Add('      </head>');
  FileList.Add('      <body>');
  FileList.Add('          <seq>');
  for i:=0 to aStringlist.Count-1 do begin
    Item:=TPlaylistenItem(aStringlist.Objects[i]);
    str:='              <media src="%s" tid="%s" />';

    id:=RandomGUI;
//    id:='{301542AB-9736-4C8E-A332-7C11D7356DC5}';
    FileList.Add(format(str,[item.FileName,id]));
  end; // for i
  FileList.Add('          </seq>');
  FileList.Add('      </body>');
  FileList.Add('</smil>');
  writeln('WPL: SaveToFile End');
end; // TPlayListWPL.SaveToFile

procedure TPlayListWPL.LoadFromFile(aStringlist: TStrings;
  const aFileName: widestring);
var
  str, str2:widestring;
  Item:TPlaylistenItem;
  tmp:TStrings;
  i, x, s1,s2:Integer;
begin
  writeln('WPL: LoadFromFile Begin');

  tmp:=TStringList.Create;
  tmp.LoadFromFile(aFileName);
  SetCurrentDir(ExtractFileDir(aFileName));

  for i:=0 to tmp.count-1 do begin
    str:=LowerCase(tmp[i]);
    if pos('<title>',str) > 0 then begin
      s1:=pos('>',str)+1; s2:=0;
      for x:=s1 to Length(str) do begin
        if str[x] = '<' then begin
          s2:=x;
          if (s1 > 0) and (s2 > 0) then begin
            Titel:=copy(str,s1,abs(s2-s1));
            break;
          end;
        end;
      end; // for x
    end; // pos
    

    if pos('media src',str) > 0 then begin
      s1:=pos('"',str)+1; s2:=0;
      for x:=s1 to Length(str) do begin
        if str[x] = '"' then begin
          s2:=x;
          if (s1 > 0) and (s2 > 0) then begin
            Item:=TPlaylistenItem.Create;
            item.FileName:=ExpandFileName(copy(str,s1,abs(s2-s1)));
            if OhneExt then begin
              aStringlist.AddObject(SplitStr(ExtractFileName(Item.FileName),'.'),Item);
              if assigned(onAddPlayListe) then
                onAddPlayListe(item.FileName,item);
            end
            else begin
              aStringlist.AddObject(ExtractFileName(Item.FileName),Item);
              if assigned(onAddPlayListe) then
                onAddPlayListe(ExtractFileName(item.FileName),item);
            end;
            break;
          end; // s1 > 0 and s2 > 0
        end; // str[x] = '"'
      end; // for x
    end; // if media src > 0
  end; // for i
  
  tmp.free;
  writeln('WPL: LoadFromFile End');
end; // TPlayListWPL.LoadFromFile

// Backup für Später evlt.
//procedure TPlayListWPL.LoadFromFile(aStringlist: TStrings;
//  const aFileName: widestring);
{var
  DOC:TXMLDocument;
  PassNode:TDOMNodeList;
  Item:TPlaylistenItem;
  i:integer;}
//begin
//  writeln('WPL: LoadFromFile');
//  writeln('Wird noch nicht unterstützt !');
 {ReadXMLFile(doc,aFileName);
  passNode:=doc.DocumentElement.GetElementsByTagName('meta');

  passNode:=doc.DocumentElement.GetElementsByTagName('title');
  Titel:=PassNode.item[0].TextContent;

  passNode:=doc.DocumentElement.GetElementsByTagName('media');
  for i:=0 to PassNode.Count-1 do begin
    Item:=TPlaylistenItem.Create;
    item.FileName:=PassNode.Item[i].Attributes.Item[0].NodeValue;
    item.Kommentar:=PassNode.Item[i].Attributes.Item[1].NodeValue;

    if OhneExt then
      aStringlist.AddObject(SplitStr(ExtractFileName(Item.FileName),'.'),Item)
    else
      aStringlist.AddObject(ExtractFileName(Item.FileName),Item);
  end;

  PassNode.Free; DOC.Free;}
//end; // TPlayListWPL.LoadFromFile

end.

