{
  Autor: Michael Springwald

  Erstellt: Samstag, 29.September.2007

  Updates:
  --------------------------------------------------------------
  - Sontag, 14.Oktober.2007      - Dienstag, 30.Oktober.2007   -
  --------------------------------------------------------------
  - Mittwoch, 31.Oktober.2007    - Dienstag, 06.November.2007  -
  --------------------------------------------------------------
  - Donnerstag, 08.November.2007 - Samstag, 24.Novmeber.2007   -
  --------------------------------------------------------------
  - Sonntag, 02.Dezember.2007    - Dienstag, 01.Janur.2008     -
  --------------------------------------------------------------
  - Mittwoch, 02.Januer.2077     - Donnerstag, 03.Januer.2008  -
  --------------------------------------------------------------
  - Mittwoch, 30.Janur.2008      - Freitag, 28.Mäzr.2008       -
  --------------------------------------------------------------
  -                              -                             -
  --------------------------------------------------------------
  -                              -                             -
  --------------------------------------------------------------
  -                              -                             -
  --------------------------------------------------------------
  -                              -                             -
  --------------------------------------------------------------

  Nochmal vielen dank an Muetze1
  http://www.delphipraxis.net/topic121870,0,asc,0.html
}

unit uplaylistenmanger;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, uplaylistbase, contnrs, dialogs;

const
// Für den Zufalls Modus
  rm_while  = 0; // Endlos(Schleife)
  rm_next   = 1; // Nächster Titel
  rm_prev   = 2; // Vorheriger Titel
  rm_random = 3; // Zufälliger Tiel

// Die Verschiedene Zustände bei einer Playlisten Änderung
  cp_save   = 0;
  cp_load   = 1;
  cp_delete = 2;
  cp_add    = 3;
  cp_clear  = 4;

// Fehler Meldungen die kommen könnten
  etWarnung       = 0;
  etFehler        = 1;
  
  etMsg0          = 'Keinen Datei namen angeben';
  etMsg1          = 'Playlist typ %s wird nicht unterstützt';
  etMsg2          = 'Datei %s gibt es nicht';
  etMsg3          = 'Playliste ist schon Leer';
  etMsg4          = 'Datei %s kann nicht gespeichert werden. Weil Playlisten Typ %s nicht unterstützt wird.';
  etMsg5          = 'Datei %s ist Leer';

type
  // Wenn ein neu Playlist geladen wird
  TOnPlayListLoad = procedure (const aPlayListenName:widestring) of Object;
  
  // Wenn eine Playliste verändert wird
  // Wird diese Ereignis ausgelöst
  TOnPlaylistenChagne = procedure (const aTyp:byte; var aStringlist:TStrings) of Object;

  // Ein Ereignis das ausgelöst wird, wenn ein Fehler auftaucht
  // Hier könnte eine Log Funktion Verwendet werden.
  TOnError = procedure (const ErrorTyp:Byte; errorMSG:widestring) of Object;

  { TPlaylistenManger }
  TPlaylistenManger = class
    fonChangePlayList: TOnPlaylistenChagne;
    fOnError: TOnError;
    FonAddPlayListenitem: TOnAddPlayliste;
    FOnPlayListenLoad: TOnPlayListLoad;
  private
    fPlayliste: TPlaylistBase;
    procedure DoError(const ErrorTyp:Byte; const ErrorMSG:widestring);
    procedure InitPlaylist(const aFileName:widestring; var aPlayliste:TPlaylistBase);
  protected

  public
    _ext:widestring;
    // Enhält den Dateinamen der geöffnenten Playliste
    FileName:widestring;
    {
      Wenn OheExt True ist, werden die Erweiterungen nicht
      in die TSTinglist geschrieben.
      
      Wenn False werden sie geschrieben

    }
    OhneExt:Boolean;

    {
      Enhält den Titel der Playlisten.

      Bei M3U und PLS ist das der Dateiname oder die Erweiterung.
      Bei WPL ist das der Titel der in der Datei steht.
    }
    Titel:widestring;

    {
      Kann bei einem Open oder Save Dialog zugeiwesen werden.
      BZW. Angehängt werden.
      
      Filter enhält alle unterstützen Playlisten
    }
    
    Filter:widestring;
    constructor Create;
    destructor Destroy; override;

    procedure SaveToFile(aStringlist:TStrings; const aFileName:widestring = '');
    procedure LoadFromFile(aStringlist:TStrings; const aFileName:widestring = '');

    procedure ClearPlayliste(aStringlist:TStrings);
    procedure AddPlayListe(aStringlist:TStrings; AddListe:TStrings);
    procedure DelPlayliste(aStringlist:TStrings; const aIndex:Integer);

    function GetPlayListenItem(aStringlist:TStrings; const aIndex:Integer):TPlaylistenItem;

    // Lädt ein Vorherrigen Tiel oder den Nächsten oder ein Zufälligen.
    // AMod ist der Modus z.b. RM_next
    // aRepeatPlayliste ob am ende Automaitsch wieder zum anfang gehen soll
    function AutoLoadTitel(const aIndex:Integer; const aCount:Integer; const aMode:Integer = 0; const aRepeatPlayliste:Boolean = False):Integer;
  published
    property onAddPlayListenitem:TOnAddPlayliste read FonAddPlayListenitem write FonAddPlayListenitem;
    property onChangePlayList:TOnPlaylistenChagne read fonChangePlayList write fonChangePlayList;
    property onError:TOnError read fOnError write fOnError;
    property OnPlayListenLoad:TOnPlayListLoad read FOnPlayListenLoad write FOnPlayListenLoad;
  end; // TPlaylistenManger

implementation

{ TPlaylistenManger }

procedure TPlaylistenManger.InitPlaylist(const aFileName: widestring; var aPlayliste: TPlaylistBase);
var
  ext:widestring;
begin
  ext := AnsiUpperCase(ExtractFileExt(aFileName));
  aPlayliste:=nil;
  if ext = '.M3U' then aPlayliste:=TPlayListM3U.Create;
  if ext = '.PLS' then aPlayliste:=TPlayListPLS.Create;
  if ext = '.WPL' then aPlayliste:=TPlayListWPL.Create;
end;

constructor TPlaylistenManger.Create;
begin
  inherited Create;
  FileName:=''; OhneExt:=true; Filter:='Alle Unterstützen Playlisten(*.m3u, *.pls, *.wpl)|*.m3u;*.pls;*.wpl|M3U Playlisten(*.M3U)|*.m3u|PLS Playlisten(*.PLS)|*.pls|WPL Playlisten(*.WPL)|*.wpl';
end;

destructor TPlaylistenManger.Destroy;
begin
  inherited;
end;

procedure TPlaylistenManger.SaveToFile(aStringlist:TStrings;  const aFileName: widestring);
var
  Playliste: TPlaylistBase;
  str,ext:widestring;
begin
  if aFilename <> '' then
    str:=aFilename
  else begin
    str:=Filename;
  end;

  // Wenn Kein Datei namen angeben wurden ist
  if str = '' then begin DoError(etFehler,etMsg0); exit; end;
  ext:=ExtractFileExt(str);
  
  InitPlaylist(ExtractFileName(str), Playliste);
  if assigned(Playliste) then begin
    Playliste.ext := _ext;
    Playliste.FileList.Clear;
    Playliste.Titel:=Titel;
    Playliste.SaveToFile(aStringlist, str);

    if FileExists(aFileName) then DeleteFile(aFileName);
    Playliste.FileList.SaveToFile(aFileName);

    if assigned(onChangePlayList) then onChangePlayList(cp_save,aStringlist);
    Playliste.Free;
  end
  else
    DoError(etFehler,Format(etMsg4,[str,ext]));
end;

procedure TPlaylistenManger.LoadFromFile(aStringlist:TStrings=Nil;  const aFileName: widestring = '');
var
  i:integer;
  Playliste: TPlaylistBase;
  tmp:TStrings;
  ext,str:widestring;
begin
  if aFilename <> '' then
    str:=aFilename
  else begin
    str:=Filename;
  end;
  
  // Wenn Kein Datei namen angeben wurden ist
  if str = '' then begin DoError(etFehler,etMsg0); exit; end;
  // Prüfen ob es die Datei gibt
  if FileExists(str) then begin
    ext:=ExtractFileExt(str);
    InitPlaylist(ExtractFileName(aFileName), Playliste);
  end
  else begin // Wenn es die Datei nicht gibt, Fehler Meldung
    DoError(etFehler,Format(etmsg2,[str]));
    exit;
  end;

  if assigned(Playliste) then begin
    Playliste.OhneExt:=OhneExt;
    Playliste.onAddPlayListe:=FonAddPlayListenitem;

    if assigned(OnPlayListenLoad) then OnPlayListenLoad(aFileName);

    if aStringlist = nil then begin
      tmp:=TStringlist.Create;
      Playliste.LoadFromFile(tmp,aFileName);
      if tmp.count = 0 then DoError(etFehler,Format(etMsg5,[aFileName]));
    end
    else begin
      Playliste.LoadFromFile(aStringlist,aFileName);
    end;
     Titel:=Playliste.Titel;
    _ext:=Playliste.ext;
    if assigned(onChangePlayList) then onChangePlayList(cp_load,tmp);
    Playliste.Free;
  end
  else
    DoError(etFehler,format(etMsg1,[ext]));
//  if tmp <> NIL then tmp.Free;
end;

procedure TPlaylistenManger.ClearPlayliste(aStringlist:TStrings);
begin
  if aStringlist.Count > 0 then
    aStringlist.Clear
  else
    DoError(etWarnung,etmsg3)
end;


procedure TPlaylistenManger.AddPlayListe(aStringlist:TStrings; AddListe:TStrings);
var
  i:Integer;
  info:TPlaylistenItem;
begin
  for i:=0 to AddListe.Count-1 do begin
   info:=TPlaylistenItem.Create;

   info.FileName:=AddListe[i];
   if OhneExt then
     aStringlist.AddObject(SplitStr(ExtractFileName(info.FileName),'.'),info)
   else
     aStringlist.AddObject(ExtractFileName(info.FileName),info)
  end;
end;

procedure TPlaylistenManger.DelPlayliste(aStringlist:TStrings; const aIndex: Integer);
begin
  aStringlist.Delete(aIndex);
end;

function TPlaylistenManger.GetPlayListenItem(aStringlist:TStrings; const aIndex: Integer): TPlaylistenItem;
var
  info:TPlaylistenItem;
begin
  info:=TPlaylistenItem.Create;
  info.FileName:=TPlaylistenItem(aStringlist.Objects[aindex]).FileName;
  info.Kommentar:=TPlaylistenItem(aStringlist.Objects[aindex]).Kommentar;
  result:=info;
end;

function TPlaylistenManger.AutoLoadTitel(const aIndex: Integer; const aCount:Integer;
  const aMode: Integer = 0; const aRepeatPlayliste:Boolean = False):Integer;
var
  m,z:Integer;
begin
  if m = -1 then m:=0 else m:=aIndex; z:=-1;
  
  case aMode of
    rm_next: if aIndex +1 <= aCount then
      z:=aIndex+1
    else begin
      if aRepeatPlayliste then z:=0;
    end;
    
    rm_prev: if
      aIndex -1 >= 0 then
        z:=aIndex-1
      else
        if aRepeatPlayliste then z:=aCount-1;
    rm_random: z:=random(aCount+1);
  end;
  
  result:=z;
end; // TPlaylistenManger.AutoLoadTitel

procedure TPlaylistenManger.DoError(const ErrorTyp: Byte;
  const ErrorMSG: widestring);
begin
  if assigned(onError) then begin
    onError(ErrorTyp,ErrorMSG);
  end;
end;

end.

